Index: /trunk/source/Lib/TLibDecoder/TDecSbac.cpp
===================================================================
--- /trunk/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -67,5 +67,5 @@
 , m_cCUSplitFlagSCModel                      ( 1,             1,                      NUM_SPLIT_FLAG_CTX                   , m_contextModels + m_numContextModels, m_numContextModels)
 , m_cCUSkipFlagSCModel                       ( 1,             1,                      NUM_SKIP_FLAG_CTX                    , m_contextModels + m_numContextModels, m_numContextModels)
-#if NH_3D_DIS
+#if NH_3D
 , m_cCUDISFlagSCModel                        ( 1,             1,                      NUM_DIS_FLAG_CTX                     , m_contextModels + m_numContextModels, m_numContextModels)
 , m_cCUDISTypeSCModel                        ( 1,             1,                      NUM_DIS_TYPE_CTX                     , m_contextModels + m_numContextModels, m_numContextModels)
@@ -73,8 +73,6 @@
 , m_cCUMergeFlagExtSCModel                   ( 1,             1,                      NUM_MERGE_FLAG_EXT_CTX               , m_contextModels + m_numContextModels, m_numContextModels)
 , m_cCUMergeIdxExtSCModel                    ( 1,             1,                      NUM_MERGE_IDX_EXT_CTX                , m_contextModels + m_numContextModels, m_numContextModels)
-#if NH_3D_ARP
+#if NH_3D
 , m_cCUPUARPWSCModel          ( 1,             1,               NUM_ARPW_CTX                  , m_contextModels + m_numContextModels, m_numContextModels)
-#endif
-#if NH_3D_IC
 , m_cCUICFlagSCModel          ( 1,             1,               NUM_IC_FLAG_CTX               , m_contextModels + m_numContextModels, m_numContextModels)
 #endif
@@ -107,18 +105,12 @@
 , m_ChromaQpAdjIdcSCModel                    ( 1,             1,                      NUM_CHROMA_QP_ADJ_IDC_CTX            , m_contextModels + m_numContextModels, m_numContextModels)
 
-#if NH_3D_DMM
+#if NH_3D
 , m_cNotDmmFlagSCModel                       ( 1,             1,                      NUM_NOTDMM_FLAG_CTX                  , m_contextModels + m_numContextModels, m_numContextModels)
 , m_cDmmModeSCModel                          ( 1,             1,                      NUM_DMM_MODE_CTX                     , m_contextModels + m_numContextModels, m_numContextModels)
-#endif
-#if NH_3D_DMM || NH_3D_SDC_INTRA || NH_3D_SDC_INTER
 , m_cDdcDataSCModel                          ( 1,             1,                      NUM_DDC_DATA_CTX                     , m_contextModels + m_numContextModels, m_numContextModels)
 , m_cSDCFlagSCModel                          ( 1,             1,                     NUM_SDC_FLAG_CTX                      , m_contextModels + m_numContextModels, m_numContextModels)
-#endif
-#if NH_3D_SDC_INTRA
 , m_cSDCResidualFlagSCModel                  ( 1,             1,                     SDC_NUM_RESIDUAL_FLAG_CTX             , m_contextModels + m_numContextModels, m_numContextModels)
 , m_cSDCResidualSCModel                      ( 1,             1,                     SDC_NUM_RESIDUAL_CTX                  , m_contextModels + m_numContextModels, m_numContextModels)
 , m_cDdcFlagSCModel                          ( 1,             1,                     NUM_DDC_FLAG_CTX                      , m_contextModels + m_numContextModels, m_numContextModels)
-#endif
-#if NH_3D_DBBP
 , m_cDBBPFlagSCModel                         ( 1,             1,                     DBBP_NUM_FLAG_CTX                     , m_contextModels + m_numContextModels, m_numContextModels)
 #endif
@@ -159,5 +151,5 @@
   m_cCUSplitFlagSCModel.initBuffer                ( sliceType, qp, (UChar*)INIT_SPLIT_FLAG );
   m_cCUSkipFlagSCModel.initBuffer                 ( sliceType, qp, (UChar*)INIT_SKIP_FLAG );
-#if NH_3D_DIS
+#if NH_3D
   m_cCUDISFlagSCModel.initBuffer                  ( sliceType, qp, (UChar*)INIT_DIS_FLAG );
   m_cCUDISTypeSCModel.initBuffer                  ( sliceType, qp, (UChar*)INIT_DIS_TYPE );
@@ -165,8 +157,6 @@
   m_cCUMergeFlagExtSCModel.initBuffer             ( sliceType, qp, (UChar*)INIT_MERGE_FLAG_EXT );
   m_cCUMergeIdxExtSCModel.initBuffer              ( sliceType, qp, (UChar*)INIT_MERGE_IDX_EXT );
-#if NH_3D_ARP
+#if NH_3D
   m_cCUPUARPWSCModel.initBuffer          ( sliceType, qp, (UChar*)INIT_ARPW );
-#endif
-#if NH_3D_IC
   m_cCUICFlagSCModel.initBuffer          ( sliceType, qp, (UChar*)INIT_IC_FLAG );
 #endif
@@ -198,18 +188,12 @@
   m_ChromaQpAdjFlagSCModel.initBuffer             ( sliceType, qp, (UChar*)INIT_CHROMA_QP_ADJ_FLAG );
   m_ChromaQpAdjIdcSCModel.initBuffer              ( sliceType, qp, (UChar*)INIT_CHROMA_QP_ADJ_IDC );
-#if NH_3D_DMM
+#if NH_3D
   m_cNotDmmFlagSCModel.initBuffer                 ( sliceType, qp, (UChar*)INIT_NOTDMM_FLAG );
   m_cDmmModeSCModel.initBuffer                    ( sliceType, qp, (UChar*)INIT_DMM_MODE );
-#endif
-#if NH_3D_DMM || NH_3D_SDC_INTRA || NH_3D_SDC_INTER
   m_cDdcDataSCModel.initBuffer                    ( sliceType, qp, (UChar*)INIT_DDC_DATA );
   m_cSDCFlagSCModel.initBuffer                    ( sliceType, qp, (UChar*)INIT_SDC_FLAG );
-#endif
-#if NH_3D_SDC_INTRA
   m_cSDCResidualFlagSCModel.initBuffer            ( sliceType, qp, (UChar*)INIT_SDC_RESIDUAL_FLAG );
   m_cSDCResidualSCModel.initBuffer                ( sliceType, qp, (UChar*)INIT_SDC_RESIDUAL );
   m_cDdcFlagSCModel.initBuffer                    ( sliceType, qp, (UChar*)INIT_DDC_FLAG );
-#endif
-#if NH_3D_DBBP
   m_cDBBPFlagSCModel.initBuffer                   ( sliceType, qp, (UChar*)INIT_DBBP_FLAG );
 #endif
@@ -512,5 +496,5 @@
 
 }
-#if NH_3D_DIS
+#if NH_3D
 Void TDecSbac::parseDIS( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
 {
@@ -642,5 +626,5 @@
 
   UInt uiSymbol;
-#if NH_3D_QTLPC
+#if NH_3D
   Bool bParseSplitFlag    = true;
   Bool    bLimQtPredFlag = pcCU->getPic()->getSlice(0)->getQtPredFlag();
@@ -651,9 +635,5 @@
   Bool rapPic = (pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR_W_RADL || pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR_N_LP || pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA);
 
-#if H_3D_FCO
-  if(bDepthMapDetect && !bIntraSliceDetect && !rapPic && bLimQtPredFlag && pcTexture->getReconMark())
-#else
   if(bDepthMapDetect && !bIntraSliceDetect && !rapPic && bLimQtPredFlag)
-#endif
   {
     TComDataCU *pcTextureCU = pcTexture->getCtu(pcCU->getCtuRsAddr());
@@ -672,5 +652,5 @@
   DTRACE_CABAC_T( "\tSplitFlag\n" )
 #endif
-#if NH_3D_QTLPC
+#if NH_3D
   }
   else
@@ -704,5 +684,5 @@
   assert ( pcCU->getSlice()->getSPS()->getLog2DiffMaxMinCodingBlockSize() == log2DiffMaxMinCodingBlockSize);
 
-#if NH_3D_QTLPC
+#if NH_3D
   Bool bParsePartSize    = true;
 
@@ -717,9 +697,5 @@
   UInt uiTexturePart = uiMode;
 
-#if H_3D_FCO
-  if(bDepthMapDetect && !bIntraSliceDetect && !rapPic && bLimQtPredFlag && pcTexture->getReconMark())
-#else
   if(bDepthMapDetect && !bIntraSliceDetect && !rapPic && bLimQtPredFlag )
-#endif
   {
     TComDataCU *pcTextureCU = pcTexture->getCtu(pcCU->getCtuRsAddr());
@@ -740,18 +716,18 @@
   if ( pcCU->isIntra( uiAbsPartIdx ) )
   {
-#if NH_3D_QTLPC
+#if NH_3D
     if(bParsePartSize)
     {
 #endif
-    uiSymbol = 1;
-    if( uiDepth == log2DiffMaxMinCodingBlockSize )
-    {
-      m_pcTDecBinIf->decodeBin( uiSymbol, m_cCUPartSizeSCModel.get( 0, 0, 0) RExt__DECODER_DEBUG_BIT_STATISTICS_PASS_OPT_ARG(ctype) );
+      uiSymbol = 1;
+      if( uiDepth == log2DiffMaxMinCodingBlockSize )
+      {
+        m_pcTDecBinIf->decodeBin( uiSymbol, m_cCUPartSizeSCModel.get( 0, 0, 0) RExt__DECODER_DEBUG_BIT_STATISTICS_PASS_OPT_ARG(ctype) );
 #if NH_MV_ENC_DEC_TRAC          
         DTRACE_CU("part_mode", uiSymbol)
 #endif        
-    }
-    eMode = uiSymbol ? SIZE_2Nx2N : SIZE_NxN;
-#if NH_3D_QTLPC
+      }
+      eMode = uiSymbol ? SIZE_2Nx2N : SIZE_NxN;
+#if NH_3D
     }
 #endif
@@ -771,5 +747,5 @@
   else
   {
-#if NH_3D_QTLPC
+#if NH_3D
     if(bParsePartSize)
     {
@@ -777,51 +753,11 @@
       {
 #endif
-    UInt uiMaxNumBits = 2;
-
-    if( uiDepth == log2DiffMaxMinCodingBlockSize && !( cuWidth == 8 && cuHeight == 8 ) )
-    {
-      uiMaxNumBits ++;
-    }
-
-    for ( UInt ui = 0; ui < uiMaxNumBits; ui++ )
-    {
-      m_pcTDecBinIf->decodeBin( uiSymbol, m_cCUPartSizeSCModel.get( 0, 0, ui) RExt__DECODER_DEBUG_BIT_STATISTICS_PASS_OPT_ARG(ctype) );
-      if ( uiSymbol )
-      {
-        break;
-      }
-      uiMode++;
-    }
-    eMode = (PartSize) uiMode;
-    if ( pcCU->getSlice()->getSPS()->getUseAMP() && uiDepth < log2DiffMaxMinCodingBlockSize )
-    {
-      if (eMode == SIZE_2NxN)
-      {
-        m_pcTDecBinIf->decodeBin(uiSymbol, m_cCUPartSizeSCModel.get( 0, 0, 3 ) RExt__DECODER_DEBUG_BIT_STATISTICS_PASS_OPT_ARG(ctype));
-        if (uiSymbol == 0)
-        {
-          m_pcTDecBinIf->decodeBinEP(uiSymbol RExt__DECODER_DEBUG_BIT_STATISTICS_PASS_OPT_ARG(ctype) );
-          eMode = (uiSymbol == 0? SIZE_2NxnU : SIZE_2NxnD);
-        }
-      }
-      else if (eMode == SIZE_Nx2N)
-      {
-        m_pcTDecBinIf->decodeBin(uiSymbol, m_cCUPartSizeSCModel.get( 0, 0, 3 ) RExt__DECODER_DEBUG_BIT_STATISTICS_PASS_OPT_ARG(ctype) );
-        if (uiSymbol == 0)
-        {
-          m_pcTDecBinIf->decodeBinEP(uiSymbol RExt__DECODER_DEBUG_BIT_STATISTICS_PASS_OPT_ARG(ctype) );
-          eMode = (uiSymbol == 0? SIZE_nLx2N : SIZE_nRx2N);
-        }
-      }
-    }
-#if NH_3D_QTLPC
-      }
-      else if(uiTexturePart == SIZE_2NxN || uiTexturePart == SIZE_2NxnU || uiTexturePart == SIZE_2NxnD)
-      {
-        UInt uiMaxNumBits = 1;
-        if ( ( pcCU->getSlice()->getSPS()->getUseAMP() && uiDepth < log2DiffMaxMinCodingBlockSize ) && uiDepth < log2DiffMaxMinCodingBlockSize )
+        UInt uiMaxNumBits = 2;
+
+        if( uiDepth == log2DiffMaxMinCodingBlockSize && !( cuWidth == 8 && cuHeight == 8 ) )
         {
           uiMaxNumBits ++;
         }
+
         for ( UInt ui = 0; ui < uiMaxNumBits; ui++ )
         {
@@ -834,4 +770,44 @@
         }
         eMode = (PartSize) uiMode;
+        if ( pcCU->getSlice()->getSPS()->getUseAMP() && uiDepth < log2DiffMaxMinCodingBlockSize )
+        {
+          if (eMode == SIZE_2NxN)
+          {
+            m_pcTDecBinIf->decodeBin(uiSymbol, m_cCUPartSizeSCModel.get( 0, 0, 3 ) RExt__DECODER_DEBUG_BIT_STATISTICS_PASS_OPT_ARG(ctype));
+            if (uiSymbol == 0)
+            {
+              m_pcTDecBinIf->decodeBinEP(uiSymbol RExt__DECODER_DEBUG_BIT_STATISTICS_PASS_OPT_ARG(ctype) );
+              eMode = (uiSymbol == 0? SIZE_2NxnU : SIZE_2NxnD);
+            }
+          }
+          else if (eMode == SIZE_Nx2N)
+          {
+            m_pcTDecBinIf->decodeBin(uiSymbol, m_cCUPartSizeSCModel.get( 0, 0, 3 ) RExt__DECODER_DEBUG_BIT_STATISTICS_PASS_OPT_ARG(ctype) );
+            if (uiSymbol == 0)
+            {
+              m_pcTDecBinIf->decodeBinEP(uiSymbol RExt__DECODER_DEBUG_BIT_STATISTICS_PASS_OPT_ARG(ctype) );
+              eMode = (uiSymbol == 0? SIZE_nLx2N : SIZE_nRx2N);
+            }
+          }
+        }
+#if NH_3D
+      }
+      else if(uiTexturePart == SIZE_2NxN || uiTexturePart == SIZE_2NxnU || uiTexturePart == SIZE_2NxnD)
+      {
+        UInt uiMaxNumBits = 1;
+        if ( ( pcCU->getSlice()->getSPS()->getUseAMP() && uiDepth < log2DiffMaxMinCodingBlockSize ) && uiDepth < log2DiffMaxMinCodingBlockSize )
+        {
+          uiMaxNumBits ++;
+        }
+        for ( UInt ui = 0; ui < uiMaxNumBits; ui++ )
+        {
+          m_pcTDecBinIf->decodeBin( uiSymbol, m_cCUPartSizeSCModel.get( 0, 0, ui) RExt__DECODER_DEBUG_BIT_STATISTICS_PASS_OPT_ARG(ctype) );
+          if ( uiSymbol )
+          {
+            break;
+          }
+          uiMode++;
+        }
+        eMode = (PartSize) uiMode;
         if(uiMode && ( ( pcCU->getSlice()->getSPS()->getUseAMP() && uiDepth < log2DiffMaxMinCodingBlockSize ) && uiDepth < log2DiffMaxMinCodingBlockSize ) && uiSymbol==1 )
         {
@@ -887,5 +863,5 @@
       DTRACE_CU("part_mode", eMode )
 #endif
-#if NH_3D_QTLPC
+#if NH_3D
     }
 #endif
@@ -937,5 +913,5 @@
   for (j=0;j<partNum;j++)
   {
-#if NH_3D_DMM
+#if NH_3D
     if( pcCU->getSlice()->getIntraSdcWedgeFlag() || pcCU->getSlice()->getIntraContourFlag() )
     {
@@ -946,10 +922,10 @@
     {
 #endif
-    m_pcTDecBinIf->decodeBin( symbol, m_cCUIntraPredSCModel.get( 0, 0, 0) RExt__DECODER_DEBUG_BIT_STATISTICS_PASS_OPT_ARG(ctype) );
-    mpmPred[j] = symbol;
+      m_pcTDecBinIf->decodeBin( symbol, m_cCUIntraPredSCModel.get( 0, 0, 0) RExt__DECODER_DEBUG_BIT_STATISTICS_PASS_OPT_ARG(ctype) );
+      mpmPred[j] = symbol;
 #if NH_MV_ENC_DEC_TRAC          
       DTRACE_CU("prev_intra_luma_pred_flag", symbol)
 #endif
-#if NH_3D_DMM
+#if NH_3D
     }
 #endif
@@ -957,51 +933,51 @@
   for (j=0;j<partNum;j++)
   {
-#if NH_3D_DMM
+#if NH_3D
     if( pcCU->getIntraDir( CHANNEL_TYPE_LUMA, absPartIdx+partOffset*j ) < NUM_INTRA_MODE )
     {
 #endif
-    Int preds[NUM_MOST_PROBABLE_MODES] = {-1, -1, -1};
-    pcCU->getIntraDirPredictor(absPartIdx+partOffset*j, preds, COMPONENT_Y);
-    if (mpmPred[j])
-    {
-      m_pcTDecBinIf->decodeBinEP( symbol RExt__DECODER_DEBUG_BIT_STATISTICS_PASS_OPT_ARG(ctype) );
-      if (symbol)
+      Int preds[NUM_MOST_PROBABLE_MODES] = {-1, -1, -1};
+      pcCU->getIntraDirPredictor(absPartIdx+partOffset*j, preds, COMPONENT_Y);
+      if (mpmPred[j])
       {
         m_pcTDecBinIf->decodeBinEP( symbol RExt__DECODER_DEBUG_BIT_STATISTICS_PASS_OPT_ARG(ctype) );
-        symbol++;
-      }
+        if (symbol)
+        {
+          m_pcTDecBinIf->decodeBinEP( symbol RExt__DECODER_DEBUG_BIT_STATISTICS_PASS_OPT_ARG(ctype) );
+          symbol++;
+        }
 #if NH_MV_ENC_DEC_TRAC          
         DTRACE_CU("mpm_idx", symbol)
 #endif
-      intraPredMode = preds[symbol];
-    }
-    else
-    {
-      m_pcTDecBinIf->decodeBinsEP( symbol, 5 RExt__DECODER_DEBUG_BIT_STATISTICS_PASS_OPT_ARG(ctype) );
-      intraPredMode = symbol;
+          intraPredMode = preds[symbol];
+      }
+      else
+      {
+        m_pcTDecBinIf->decodeBinsEP( symbol, 5 RExt__DECODER_DEBUG_BIT_STATISTICS_PASS_OPT_ARG(ctype) );
+        intraPredMode = symbol;
 #if NH_MV_ENC_DEC_TRAC          
         DTRACE_CU("rem_intra_luma_pred_mode", symbol)
 #endif        
 
-      //postponed sorting of MPMs (only in remaining branch)
-      if (preds[0] > preds[1])
-      {
-        std::swap(preds[0], preds[1]);
-      }
-      if (preds[0] > preds[2])
-      {
-        std::swap(preds[0], preds[2]);
-      }
-      if (preds[1] > preds[2])
-      {
-        std::swap(preds[1], preds[2]);
-      }
-      for ( UInt i = 0; i < NUM_MOST_PROBABLE_MODES; i++ )
-      {
-        intraPredMode += ( intraPredMode >= preds[i] );
-      }
-    }
-    pcCU->setIntraDirSubParts(CHANNEL_TYPE_LUMA, (UChar)intraPredMode, absPartIdx+partOffset*j, depth );
-#if NH_3D_DMM
+          //postponed sorting of MPMs (only in remaining branch)
+          if (preds[0] > preds[1])
+          {
+            std::swap(preds[0], preds[1]);
+          }
+          if (preds[0] > preds[2])
+          {
+            std::swap(preds[0], preds[2]);
+          }
+          if (preds[1] > preds[2])
+          {
+            std::swap(preds[1], preds[2]);
+          }
+          for ( UInt i = 0; i < NUM_MOST_PROBABLE_MODES; i++ )
+          {
+            intraPredMode += ( intraPredMode >= preds[i] );
+          }
+      }
+      pcCU->setIntraDirSubParts(CHANNEL_TYPE_LUMA, (UChar)intraPredMode, absPartIdx+partOffset*j, depth );
+#if NH_3D
     }
 #endif
@@ -1679,5 +1655,5 @@
   else
   {
-    beValid = pcCU->getSlice()->getPPS()->getSignHideFlag();
+    beValid = pcCU->getSlice()->getPPS()->getSignDataHidingEnabledFlag();
   }
 
@@ -2269,5 +2245,5 @@
 }
 
-#if NH_3D_ARP
+#if NH_3D
 Void TDecSbac::parseARPW( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
 {
@@ -2289,7 +2265,5 @@
   pcCU->setARPWSubParts( ( UChar )( uiW ) , uiAbsPartIdx, uiDepth );  
 }
-#endif
-
-#if NH_3D_IC
+
 /** parse illumination compensation flag
  * \param pcCU
@@ -2317,19 +2291,12 @@
   pcCU->setICFlagSubParts( uiSymbol ? true : false , uiAbsPartIdx, 0, uiDepth );
 }
-#endif
-
-#if NH_3D_DMM || NH_3D_SDC_INTRA || NH_3D_SDC_INTER
+
 Void TDecSbac::parseDeltaDC( TComDataCU* pcCU, UInt absPartIdx, UInt depth )
 {
-#if NH_3D_SDC_INTRA || NH_3D_SDC_INTER
   if( !(pcCU->getSDCFlag( absPartIdx )) )
-#endif
-#if NH_3D_DMM
-  if( !(pcCU->isIntra( absPartIdx ) && isDmmMode( pcCU->getIntraDir( CHANNEL_TYPE_LUMA, absPartIdx ) )) )
-#endif
-    assert( 0 );
+    if( !(pcCU->isIntra( absPartIdx ) && isDmmMode( pcCU->getIntraDir( CHANNEL_TYPE_LUMA, absPartIdx ) )) )
+      assert( 0 );
 
   UInt symbol = 1;
-#if NH_3D_SDC_INTRA
   if( pcCU->isIntra( absPartIdx ) && pcCU->getSDCFlag( absPartIdx ))
   {
@@ -2338,10 +2305,6 @@
     assert( pcCU->getTransformIdx(absPartIdx) == 0 );
     assert( pcCU->getCbf(absPartIdx, COMPONENT_Y) == 1 );
-    }
-#endif
-  UInt uiNumSegments = 1;
-#if NH_3D_DMM
-  uiNumSegments = isDmmMode( pcCU->getIntraDir( CHANNEL_TYPE_LUMA, absPartIdx ) ) ? 2 : 1;
-#endif
+  }
+  UInt uiNumSegments = isDmmMode( pcCU->getIntraDir( CHANNEL_TYPE_LUMA, absPartIdx ) ) ? 2 : 1;
 
   for( UInt segment = 0; segment < uiNumSegments; segment++ )
@@ -2355,5 +2318,4 @@
     if( pcCU->isIntra( absPartIdx ) )
     {
-#if NH_3D_SDC_INTRA
       if( pcCU->getSDCFlag( absPartIdx ) )
       {
@@ -2362,18 +2324,11 @@
       else
       {
-#endif
-#if NH_3D_DMM
         pcCU->setDmmDeltaDC( getDmmType( pcCU->getIntraDir( CHANNEL_TYPE_LUMA, absPartIdx ) ), segment, absPartIdx, valDeltaDC );
-#endif
-#if NH_3D_SDC_INTRA
-      }
-#endif
-    }
-#if NH_3D_SDC_INTER
+      }
+    }
     else
     {
       pcCU->setSDCSegmentDCOffset( valDeltaDC, segment, absPartIdx );
     }
-#endif
   }
 }
@@ -2419,6 +2374,5 @@
   return;
 }
-#endif
-#if NH_3D_DMM
+
 Void TDecSbac::xParseIntraDepthMode( TComDataCU* pcCU, UInt absPartIdx, UInt depth )
 {
@@ -2488,6 +2442,5 @@
   ruiTabIdx = uiIdx;
 }
-#endif
-#if NH_3D_SDC_INTRA || NH_3D_SDC_INTER
+
 Void TDecSbac::parseSDCFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
 {
@@ -2510,7 +2463,4 @@
 }
 
-#endif
-
-#if NH_3D_DBBP
 Void TDecSbac::parseDBBPFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
 {
Index: /trunk/source/Lib/TLibDecoder/TDecSbac.h
===================================================================
--- /trunk/source/Lib/TLibDecoder/TDecSbac.h	(revision 1412)
+++ /trunk/source/Lib/TLibDecoder/TDecSbac.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -108,21 +108,13 @@
   Void  xReadCoefRemainExGolomb ( UInt &rSymbol, UInt &rParam, const Bool useLimitedPrefixLength, const Int maxLog2TrDynamicRange );
 #endif
-#if NH_3D_DMM || NH_3D_SDC_INTRA || NH_3D_SDC_INTER
+#if NH_3D
   Void  xReadExGolombLevelDdc( UInt& ruiSymbol );
   Void  xParseDeltaDC        ( Pel& rValDeltaDC, UInt uiNumSeg );
-#endif
-#if NH_3D_DMM
   Void  xParseIntraDepthMode ( TComDataCU* pcCU, UInt absPartIdx, UInt depth );
   Void  xParseDmmData        ( TComDataCU* pcCU, UInt absPartIdx, UInt depth );
   Void  xParseDmm1WedgeIdx   ( UInt& ruiTabIdx, Int iNumBit );
-#endif
-#if NH_3D_SDC_INTRA
   Void  xParseSDCResidualData     ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth, UInt uiPart );
-#endif
-#if NH_3D_SDC_INTRA || NH_3D_SDC_INTER
   Void  parseSDCFlag         ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
-#endif
-#if NH_3D_DBBP
-  Void parseDBBPFlag        ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
+  Void  parseDBBPFlag        ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
 #endif
 
@@ -134,8 +126,6 @@
 
   Void parseSkipFlag      ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
-#if NH_3D_DIS
+#if NH_3D
   Void parseDIS          ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
-#endif
-#if NH_3D_DMM || NH_3D_SDC_INTRA || NH_3D_SDC_INTER
   Void  parseDeltaDC      ( TComDataCU* pcCU, UInt absPartIdx, UInt depth );
 #endif
@@ -144,8 +134,6 @@
   Void parseMergeFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth, UInt uiPUIdx );
   Void parseMergeIndex    ( TComDataCU* pcCU, UInt& ruiMergeIndex );
-#if NH_3D_ARP
+#if NH_3D
   Void parseARPW          ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
-#endif
-#if NH_3D_IC
   Void parseICFlag        ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
 #endif
@@ -183,5 +171,5 @@
   ContextModel3DBuffer m_cCUSplitFlagSCModel;
   ContextModel3DBuffer m_cCUSkipFlagSCModel;
-#if NH_3D_DIS
+#if NH_3D
   ContextModel3DBuffer m_cCUDISFlagSCModel;
   ContextModel3DBuffer m_cCUDISTypeSCModel;
@@ -189,8 +177,6 @@
   ContextModel3DBuffer m_cCUMergeFlagExtSCModel;
   ContextModel3DBuffer m_cCUMergeIdxExtSCModel;
-#if NH_3D_ARP
+#if NH_3D
   ContextModel3DBuffer m_cCUPUARPWSCModel;
-#endif
-#if NH_3D_IC
   ContextModel3DBuffer m_cCUICFlagSCModel;
 #endif
@@ -226,18 +212,12 @@
   ContextModel3DBuffer m_ChromaQpAdjFlagSCModel;
   ContextModel3DBuffer m_ChromaQpAdjIdcSCModel;
-#if NH_3D_DMM
+#if NH_3D
   ContextModel3DBuffer m_cNotDmmFlagSCModel;
   ContextModel3DBuffer m_cDmmModeSCModel;
-#endif
-#if NH_3D_DMM || NH_3D_SDC_INTRA || NH_3D_SDC_INTER
   ContextModel3DBuffer m_cDdcDataSCModel;
   ContextModel3DBuffer m_cSDCFlagSCModel;
-#endif
-#if NH_3D_SDC_INTRA  
   ContextModel3DBuffer m_cSDCResidualFlagSCModel;
   ContextModel3DBuffer m_cSDCResidualSCModel;
   ContextModel3DBuffer m_cDdcFlagSCModel;
-#endif
-#if NH_3D_DBBP
   ContextModel3DBuffer m_cDBBPFlagSCModel;
 #endif
Index: /trunk/source/Lib/TLibDecoder/TDecSlice.cpp
===================================================================
--- /trunk/source/Lib/TLibDecoder/TDecSlice.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibDecoder/TDecSlice.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -37,4 +37,5 @@
 
 #include "TDecSlice.h"
+#include "TDecConformance.h"
 
 //! \ingroup TLibDecoder
@@ -61,8 +62,9 @@
 }
 
-Void TDecSlice::init(TDecEntropy* pcEntropyDecoder, TDecCu* pcCuDecoder)
+Void TDecSlice::init(TDecEntropy* pcEntropyDecoder, TDecCu* pcCuDecoder, TDecConformanceCheck *pDecConformanceCheck)
 {
   m_pcEntropyDecoder  = pcEntropyDecoder;
   m_pcCuDecoder       = pcCuDecoder;
+  m_pDecConformanceCheck = pDecConformanceCheck;
 }
 
@@ -130,5 +132,5 @@
     }
   }
-#if  NH_3D_DLT
+#if  NH_3D
   if( pcSlice->getPPS()->getDLT() != NULL )
   {
@@ -186,4 +188,8 @@
 #endif
 
+#if DECODER_PARTIAL_CONFORMANCE_CHECK != 0
+    const UInt numRemainingBitsPriorToCtu=ppcSubstreams[uiSubStrm]->getNumBitsLeft();
+#endif
+
     if ( pcSlice->getSPS()->getUseSAO() )
     {
@@ -224,4 +230,13 @@
 
     m_pcCuDecoder->decodeCtu     ( pCtu, isLastCtuOfSliceSegment );
+
+#if DECODER_PARTIAL_CONFORMANCE_CHECK != 0
+    const UInt numRemainingBitsPostCtu=ppcSubstreams[uiSubStrm]->getNumBitsLeft(); // NOTE: Does not account for changes in buffered bits in CABAC decoder, although it's probably good enough.
+    if (TDecConformanceCheck::doChecking() && m_pDecConformanceCheck)
+    {
+      m_pDecConformanceCheck->checkCtuDecoding(numRemainingBitsPriorToCtu-numRemainingBitsPostCtu);
+    }
+#endif
+
     m_pcCuDecoder->decompressCtu ( pCtu );
 
Index: /trunk/source/Lib/TLibDecoder/TDecSlice.h
===================================================================
--- /trunk/source/Lib/TLibDecoder/TDecSlice.h	(revision 1412)
+++ /trunk/source/Lib/TLibDecoder/TDecSlice.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -58,4 +58,6 @@
 // ====================================================================================================================
 
+class TDecConformanceCheck;
+
 /// slice decoder class
 class TDecSlice
@@ -65,4 +67,5 @@
   TDecEntropy*    m_pcEntropyDecoder;
   TDecCu*         m_pcCuDecoder;
+  TDecConformanceCheck *m_pDecConformanceCheck;
 
   TDecSbac        m_lastSliceSegmentEndContextState;    ///< context storage for state at the end of the previous slice-segment (used for dependent slices only).
@@ -73,5 +76,5 @@
   virtual ~TDecSlice();
 
-  Void  init              ( TDecEntropy* pcEntropyDecoder, TDecCu* pcMbDecoder );
+  Void  init              ( TDecEntropy* pcEntropyDecoder, TDecCu* pcMbDecoder, TDecConformanceCheck *pDecConformanceCheck );
   Void  create            ();
   Void  destroy           ();
Index: /trunk/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- /trunk/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -37,4 +37,6 @@
 #include "NALread.h"
 #include "TDecTop.h"
+#include "TDecConformance.h"
+
 #if NH_MV
 ParameterSetManager TDecTop::m_parameterSetManager;
@@ -227,10 +229,8 @@
   }
 
-#if !H_3D_FCO
   if ( pcSlice->getIsDepth())
   {
     return;
   }
-#endif
 
   Int curPoc = pcSlice->getPOC();
@@ -376,4 +376,7 @@
   , m_warningMessageSkipPicture(false)
 #endif
+#if MCTS_ENC_CHECK
+  , m_tmctsCheckEnabled(false)
+#endif
   , m_prefixSEINALUs()
 {
@@ -471,6 +474,10 @@
 #endif
   m_cGopDecoder.init( &m_cEntropyDecoder, &m_cSbacDecoder, &m_cBinCABAC, &m_cCavlcDecoder, &m_cSliceDecoder, &m_cLoopFilter, &m_cSAO);
-  m_cSliceDecoder.init( &m_cEntropyDecoder, &m_cCuDecoder );
+  m_cSliceDecoder.init( &m_cEntropyDecoder, &m_cCuDecoder, &m_conformanceCheck );
+#if MCTS_ENC_CHECK
+  m_cEntropyDecoder.init(&m_cPrediction, &m_conformanceCheck );
+#else
   m_cEntropyDecoder.init(&m_cPrediction);
+#endif
 }
 
@@ -506,5 +513,9 @@
     rpcPic = new TComPic();
 
+#if REDUCED_ENCODER_MEMORY
+    rpcPic->create ( sps, pps, false, true);
+#else
     rpcPic->create ( sps, pps, true);
+#endif
 
     m_cListPic.pushBack( rpcPic );
@@ -543,5 +554,9 @@
   }
   rpcPic->destroy();
+#if REDUCED_ENCODER_MEMORY
+  rpcPic->create ( sps, pps, false, true);
+#else
   rpcPic->create ( sps, pps, true);
+#endif
 }
 
@@ -692,4 +707,7 @@
 
     xParsePrefixSEImessages();
+#if MCTS_ENC_CHECK
+    xAnalysePrefixSEImessages();
+#endif
 
 #if RExt__HIGH_BIT_DEPTH_SUPPORT==0
@@ -726,5 +744,5 @@
     sps=pSlice->getSPS();
 
-#if NH_MV
+#if NH_MV    
     pSlice->setPic( m_pcPic );
     vps=pSlice->getVPS();
@@ -772,5 +790,9 @@
     // Recursive structure
     m_cCuDecoder.create ( sps->getMaxTotalCUDepth(), sps->getMaxCUWidth(), sps->getMaxCUHeight(), sps->getChromaFormatIdc() );
+#if MCTS_ENC_CHECK
+    m_cCuDecoder.init   ( &m_cEntropyDecoder, &m_cTrQuant, &m_cPrediction, &m_conformanceCheck );
+#else
     m_cCuDecoder.init   ( &m_cEntropyDecoder, &m_cTrQuant, &m_cPrediction );
+#endif
     m_cTrQuant.init     ( sps->getMaxTrSize() );
 
@@ -807,4 +829,7 @@
     xParsePrefixSEImessages();
 
+#if MCTS_ENC_CHECK
+    xAnalysePrefixSEImessages();
+#endif
     // Check if any new SEI has arrived
     if(!m_SEIs.empty())
@@ -845,4 +870,29 @@
   }
 }
+
+#if MCTS_ENC_CHECK
+Void TDecTop::xAnalysePrefixSEImessages()
+{
+  if (m_tmctsCheckEnabled)
+  {
+    SEIMessages mctsSEIs = getSeisByType(m_SEIs, SEI::TEMP_MOTION_CONSTRAINED_TILE_SETS);
+    for (SEIMessages::iterator it = mctsSEIs.begin(); it != mctsSEIs.end(); it++)
+    {
+      SEITempMotionConstrainedTileSets *mcts = (SEITempMotionConstrainedTileSets*)(*it);
+      if (!mcts->m_each_tile_one_tile_set_flag)
+      {
+        printf("cannot (yet) check Temporal constrained MCTS if each_tile_one_tile_set_flag is not enabled\n");
+        exit(1);
+      }
+      else
+      {
+        printf("MCTS check enabled!\n");
+        m_conformanceCheck.enableTMctsCheck(true);
+      }
+    }
+  }
+}
+#endif
+
 
 #if !NH_MV
@@ -1023,9 +1073,15 @@
   xActivateParameterSets();
 
+
+
+  TComSlice* pcSlice = m_pcPic->getPicSym()->getSlice(m_uiSliceIdx);
+
+  if (TDecConformanceCheck::doChecking())
+  {
+    m_conformanceCheck.checkSliceActivation(*pcSlice, nalu, *m_pcPic, m_bFirstSliceInBitstream, m_bFirstSliceInSequence, m_bFirstSliceInPicture);
+  }
+
   m_bFirstSliceInSequence = false;
   m_bFirstSliceInBitstream  = false;
-
-
-  TComSlice* pcSlice = m_pcPic->getPicSym()->getSlice(m_uiSliceIdx);
 
 #endif
@@ -1105,8 +1161,6 @@
         }
       }
-#if NH_3D_NBDV
+#if NH_3D
       pcSlice->setDefaultRefView();
-#endif
-#if NH_3D_ARP
       pcSlice->setPocsInCurrRPSs();
       pcSlice->setARPStepNum(m_dpb);
@@ -1155,5 +1209,5 @@
       //---------------
       pcSlice->setRefPOCList();
-#if  NH_3D_TMVP
+#if  NH_3D
       if(pcSlice->getLayerId())
       {
@@ -1253,5 +1307,5 @@
   pps->setLayerId( getLayerId() );
 #endif
-#if NH_3D_DLT
+#if NH_3D
   // create mapping from depth layer indexes to layer ids
   Int j=0;
@@ -1863,7 +1917,16 @@
     {
       Int profileIdc = vps->getPTL( vps->getProfileTierLevelIdx( m_targetOlsIdx, lIdx ) )->getGeneralPTL()->getProfileIdc();
-      assert( profileIdc == 1 || profileIdc == 6 || profileIdc == 8 );
-
-      if (  profileIdc == 6 )
+
+#if !NH_MV_ALLOW_NON_CONFORMING
+      assert( profileIdc == Profile::MAIN || profileIdc == Profile::MULTIVIEWMAIN|| profileIdc == Profile::MAIN3D );
+#else
+      assert( profileIdc == Profile::MAIN || profileIdc == Profile::MAIN10 || profileIdc == Profile::MULTIVIEWMAIN|| profileIdc == Profile::MAIN3D || profileIdc == Profile::NONE || profileIdc == Profile::MULTIVIEWMAIN_NONCONFORMING || profileIdc == Profile::MAIN3D_NONCONFORMING  );
+#endif 
+
+      if (   profileIdc == Profile::MULTIVIEWMAIN
+#if NH_MV_ALLOW_NON_CONFORMING
+      ||     profileIdc == Profile::MULTIVIEWMAIN_NONCONFORMING
+#endif
+        )
       {
         m_decodingProcess = ANNEX_G;
@@ -1873,5 +1936,9 @@
         m_decodingProcess = ANNEX_H;
       }
-      else if (profileIdc == 8 )
+      else if (profileIdc == Profile::MAIN3D 
+#if NH_MV_ALLOW_NON_CONFORMING
+      ||     profileIdc == Profile::MAIN3D_NONCONFORMING
+#endif  
+        )
       {
         m_decodingProcess = ANNEX_I;
Index: /trunk/source/Lib/TLibDecoder/TDecTop.h
===================================================================
--- /trunk/source/Lib/TLibDecoder/TDecTop.h	(revision 1412)
+++ /trunk/source/Lib/TLibDecoder/TDecTop.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -52,4 +52,5 @@
 #include "TDecCAVLC.h"
 #include "SEIread.h"
+#include "TDecConformance.h"
 
 class InputNALUnit;
@@ -204,4 +205,5 @@
   TComLoopFilter          m_cLoopFilter;
   TComSampleAdaptiveOffset m_cSAO;
+  TDecConformanceCheck    m_conformanceCheck;
 
   Bool isSkipPictureForBLA(Int& iPOCLastDisplay);
@@ -236,4 +238,9 @@
 #endif
 
+#if MCTS_ENC_CHECK
+  Bool                    m_tmctsCheckEnabled;
+
+#endif
+
 #if NH_MV
   // Class interface 
@@ -286,5 +293,7 @@
 
   Void setDecodedPictureHashSEIEnabled(Int enabled) { m_cGopDecoder.setDecodedPictureHashSEIEnabled(enabled); }
-
+#if MCTS_ENC_CHECK
+  Void setTMctsCheckEnabled(Bool enabled) { m_tmctsCheckEnabled = enabled; }
+#endif
   Void  init();
 #if !NH_MV
@@ -405,4 +414,7 @@
 
   Void      xParsePrefixSEImessages();
+#if MCTS_ENC_CHECK
+  Void      xAnalysePrefixSEImessages();
+#endif
   Void      xParsePrefixSEIsForUnknownVCLNal();
 
